/*
* Delivered as a contribution to Web Services Interoperability
* Organization (WS-I) under Section (2) of the WS-I IPR Agreement.
*
* Copyright (c) 2003 Sun Microsystems, Inc.
* All rights reserved. 
*/

package com.sun.wsi.scm.logging;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.Vector;
import java.text.SimpleDateFormat;

import javax.xml.rpc.server.ServiceLifecycle;
import javax.xml.rpc.JAXRPCException;

import java.sql.Timestamp;

import com.sun.wsi.scm.util.WSIConstants;
import com.sun.wsi.scm.util.DBConnectionPool;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import javax.xml.soap.SOAPElement;

public class LoggingFacilityLogPortTypeImpl implements LoggingFacilityLogPortType, WSIConstants, ServiceLifecycle {

	Log logger = null;
	DBConnectionPool dbPool = null;

	public void init(Object context) {
		logger = LogFactory.getLog(LOGGER);

		dbPool = DBConnectionPool.getInstance(context);
	}

	public void logEvent(LogEventRequestType request) {
		if (logger.isTraceEnabled())
			logger.trace("logEvent");	

		Timestamp timestamp = new Timestamp(Calendar.getInstance().getTimeInMillis());
		Vector setters = new Vector();
		setters.add(request.getDemoUserID());
		setters.add(request.getServiceID());
		setters.add(request.getEventID());
		setters.add(request.getEventDescription());
		setters.add(timestamp);

		dbPool.insert(DBConnectionPool.LOGGING, setters);

		return;
	}

	public GetEventsResponseType getEvents(GetEventsRequestType request) throws GetEventsFaultType {
		if (logger.isTraceEnabled())
			logger.trace("getEvents");	
		GetEventsResponseType response = new GetEventsResponseType();

		Vector setters = new Vector();
		setters.add(request.getDemoUserID());
		ArrayList list = dbPool.query(DBConnectionPool.LOGGING, setters);
		LogEntry[] logEntryArray = (LogEntry[])list.toArray(new LogEntry[0]);
		response.setLogEntry(logEntryArray);

		return response;
	}

	public void destroy() { }

}

